//---
//	render: Rendering functions
//---

#ifndef TEX_RENDER
#define TEX_RENDER

/* Rendering-related interface functions */
extern void (*TeX_pixel)(int x, int y, int color);
extern void (*TeX_line)(int x1, int y1, int x2, int y2, int color);
extern void (*TeX_size)(char const * str, int *width, int *height);
extern void (*TeX_text)(char const * str, int x, int y, int color);

/* render_node() - Recursively render a node
   This function all nodes types (including text). The node's size must have
   been computed first. */
void render_node(struct TeX_Node const * node, int x, int y, int color);

/* render_flow() - Render a flow and all its components
   This function arranges and renders all horizontal objects in a flow. */
void render_flow(struct TeX_Flow const * flow, int x, int y, int color);

#endif /* TEX_RENDER */
